#include "testApp.h"
#include "ofMain.h"

//--------------------------------------------------------------
void testApp::setup(){

	
	// macs by default run on non vertical sync, which can make animation very, very fast
	// this fixes that: 
	
	ofSetVerticalSync(true);
	
	// set background: 
	
	ofEnableAlphaBlending();
	ofBackground(30,30,30);

	
	eye.pos.x = 0;
	eye.pos.y = 0;
	eye.colorR = 255;
	eye.colorG = 255;
	eye.colorB = 255;
	eye.radius = 10;
	
	pupil.pos.x = 0;
	pupil.pos.y = 0;
	pupil.colorR = 0;
	pupil.colorG = 0;
	pupil.colorB = 0;
	pupil.radius = 4;
	
	eye2.pos.x = 0;
	eye2.pos.y = 0;
	eye2.colorR = 255;
	eye2.colorG = 255;
	eye2.colorB = 255;
	eye2.radius = 10;
	
	pupil2.pos.x = 0;
	pupil2.pos.y = 0;
	pupil2.colorR = 0;
	pupil2.colorG = 0;
	pupil2.colorB = 0;
	pupil2.radius = 4;
	
	
	for (int i = 0; i < 50; i++) {
		Body[i].pos.x = mouseX+10;
		Body[i].pos.y = mouseX+10;
		Body[i].catchUpSpeed = .03+.002*(i+1);
		/*Body[i].colorR = 155+i*2;
		Body[i].colorG = 155+i*2;
		Body[i].colorB = 155+i*2;*/
		
		//color changes based on x-distance from mouseX
		Body[i].colorR = 100 + ofMap(mouseX, 0, ofGetWidth(), 0, 20); //190 ; 0, 10
		Body[i].colorG = 50 + ofMap(mouseX, 0, ofGetWidth(), 0, 200); //0, 100
		Body[i].colorB = Body[i].colorG;
		
		//Body[i].colorG = 50 + ofMap(ABS(mouseX - Body[i].pos.x), 0, ofGetWidth(), 0, 205);
		//Body[i].colorB = 50 + ofMap(ABS(mouseX - Body[i].pos.x), 0, ofGetWidth(), 0, 205);//ABS(mouseX - Body[i].pos.x);
		
	} // end for
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	// place eye according to mouse position
	eye.pos.set(mouseX-eye.radius-5,mouseY-eye.radius-10);
	eye2.pos.set(mouseX+eye.radius+5,mouseY-eye.radius-10);
	
	
	// place pupil according to eye position
	pupil.pos.set(eye.pos.x, eye.pos.y);
	pupil2.pos.set(eye2.pos.x, eye2.pos.y);	
	

	// created creatures body
	for (int i = 0; i < 50; i++) {
		Body[i].radius = 51-i*1;
		
		// set first body piece to xeno to eye's position
		if (i == 0) {
			Body[i].pos.set(mouseX, mouseY);
			Body[i].catchUpSpeed = .12;
		}
		
		// all but first body piece xeno just off previous body piece
		else {
			//Body[i].xenoToPoint(Body[i-1].pos.x+3, Body[i-1].pos.y);
			Body[i].xenoToPoint(Body[i-1].pos.x+Body[i-1].radius/4, Body[i-1].pos.y);
			Body[i].catchUpSpeed = Body[i-1].catchUpSpeed-.000001*i;
		}
		
		//color changes based on x-distance from mouseX
		//Body[i].colorR = 100 + ofMap(mouseX, 0, ofGetWidth(), 0, 20); //190 ; 0, 10
		//Body[i].colorG = 50 + ofMap(mouseX, 0, ofGetWidth(), 0, 200); //0, 100
		//Body[i].colorB = Body[i].colorG;
		
		// body color changes based on its position
		Body[i].colorR = 170 - ofMap(Body[i].pos.x, 0, ofGetWidth(), 0, 255); //190 ; 0, 10
		Body[i].colorG = 50 + ofMap(Body[i].pos.y, 0, ofGetWidth(), 0, 100); //0, 100
		//Body[i].colorB = 0 + ofMap(Body[i].pos.y-Body[i].pos.x, 0, ofGetWidth(), 0, 255); //0, 100
		Body[i].colorB = ofMap(sin(ofGetElapsedTimef()), -1, 1, 0, 255);
		
	} // end for

} // end update


//--------------------------------------------------------------
void testApp::draw(){


	for (int i = 0; i < 50; i++) {
		Body[i].draw();
	} // end for

	
	
	float sinOfTime				= sin( ofGetElapsedTimef() + 2.5*PI);
	float sinOfTimeMapped		= ofMap( sinOfTime, -1, 1, 0, 255);
	
	
	eye.colorG = sinOfTimeMapped;
	eye.colorB = 255-sinOfTimeMapped;
	eye2.colorG = sinOfTimeMapped;
	eye2.colorB = 255-sinOfTimeMapped;
	
	float sinOfTime2			= sin( ofGetElapsedTimef() + PI);
	float sinOfTimeMapped2		= ofMap( sinOfTime2, -1, 1, 50, 255);
	
	pupil.colorG = sinOfTimeMapped2;
	pupil2.colorG = sinOfTimeMapped2;
	pupil.colorB = 255 - sinOfTimeMapped2;
	pupil2.colorB = 255 - sinOfTimeMapped2;
	
	
	eye.draw();
	eye2.draw();
	pupil.draw();
	pupil2.draw();
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
